import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        long time = System.currentTimeMillis();
        int n = nextInt();
        long m = nextLong();
        long[][] a = new long[n][3];
        long max = 0;
        for (int i = 0; i < n; i++) {
            a[i][0] = nextLong();
            a[i][1] = nextLong();
            a[i][2] = nextLong();
            max = Math.max(max, a[i][0]);
        }
        long sum = 0;
        long k = 0;
        for (int i = 0; i < n; i++) {
            sum += (a[i][1] * a[i][0]) + (a[i][2] * (max - a[i][0]));
            k += a[i][2];
        }
        if (sum <= m) {
            System.out.println(max + (long) (Math.ceil((double) (m - sum) / k)));
            return;
        }
        long l = 0;
        long r = m;
        while (l + 1 < r) {
            long i = (l + r) / 2;
            sum = 0;
            for (int j = 0; j < n; j++) {
                if (a[j][0] > i) {
                    sum += a[j][1] * i;
                } else {
                    int u = 0;
                    for (long o = a[j][1] * a[j][0]; o >= 1; o/=10) {
                        u++;
                    }
                    for (long o = a[j][2]; o >= 1; o/=10) {
                        u++;
                    }
                    for (long o = i - a[j][0]; o >= 1; o/=10) {
                        u++;
                    }
                    if(u <= 18) {
                        sum += (a[j][1] * a[j][0]) + (a[j][2] * (i - a[j][0]));
                    } else {
                        sum = m;
                    }
                }
            }
            if (sum < m) {
                l = i;
            } else {
                r = i;
            }
        }
        System.out.println(r);
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}